DIV42:
;
;ON ENTRY:	R7,6,5,4 = DIVIDEND
;		R3,2 = DIVISOR
;ON EXIT:	R6,5,4 = QUOTIENT
;		R3,2 = DIVISOR
;		FRACTION REMAINDER > 1/2 ADDS ONE TO QUOTIENT
;		C=1 IF OVERFLOW ERROR
;REG USED:	RB0 0-7,A
;REG MOD:	RB0 0-7,A
;NESTING:	0
;
	MOV	R0,#0
	MOV	R1,#24
;
	CALL	DSUB
	JC	DIV42_1		;DIVIDEND / DIVISOR > 256*256?
	CALL	DADD		;YES
	CLR	C
	CPL	C		;SET OVERFLOW FLAG = 1.
DIV42_R:
	MOV	R7,#0
	RET
DIV42_1:
	CALL	DADD
	CLR	C
DIV42_2:
	CALL	DRLC
	JNC	DIV42_4
	CALL	DSUB
	CLR	C
	CPL	C
DIV42_3:
	DJNZ	R1,DIV42_2
	CALL	DRLC
	JC	DIV42_6
	CALL	DSUB
	JNC	DIV42_6
	SJMP	DIV42_R
DIV42_4:
	CALL	DSUB
	JNC	DIV42_5
	CALL	DADD
	CLR	C
	SJMP	DIV42_3
DIV42_5:
	CPL	C
	SJMP	DIV42_3
DIV42_6:
	MOV	A,R4
	ADD	A,#1
	MOV	R4,A
	MOV	A,R5
	ADDC	A,#0
	MOV	R5,A
	MOV	A,R6
	ADDC	A,#0
	MOV	R6,A
	JNC	DIV42_R
	CLR	A
	CPL	A
	MOV	R4,A
	MOV	R5,A
	MOV	R6,A
	SJMP	DIV42_R
;
;
DSUB:				;R0,7=R0,7-R2,3
	CLR	C
	MOV	A,R7
	SUBB	A,R2
	MOV	R7,A
	MOV	A,R0
	SUBB	A,R3
	MOV	R0,A
	RET
;
;
DADD:
	MOV	A,R7
	ADD	A,R2
	MOV	R7,A
	MOV	A,R0
	ADDC	A,R3
	MOV	R0,A
	RET
;
;
DRLC:
	XCH	A,R4
	RLC	A
	XCH	A,R4
	XCH	A,R5
	RLC	A
	XCH	A,R5
	XCH	A,R6
	RLC	A
	XCH	A,R6
	XCH	A,R7
	RLC	A
	XCH	A,R7
	MOV	A,R0
	RLC	A
	MOV	R0,A
	RET
;
